import { Application, Router } from "oak";
import React from "react";
import ReactDOMServer from "react-dom/server";
import App from "/app.tsx";

let bundle = "";
Deno.emit("./src/app_client.tsx", {
  bundle: "classic",
  compilerOptions: { lib: ["dom", "dom.iterable", "esnext"] },
  importMapPath: "./importmap.json",
}).then(result => bundle = result.files["deno:///bundle.js"]);


const router = new Router();
router.get("/", (context) => { context.response.body =
`<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>
    <h1>v 2.0</h1>
    <div id="root">${ReactDOMServer.renderToString(<App />)}</div>
    <script>${bundle}</script>
</body>
</html>`;
});

const app = new Application();
app.use(router.routes());
app.use(router.allowedMethods());
app.listen({ port:8000 });